/************************************************************************/
/*  t@C  :ctrl.c													*/
/*  H/W			:Pi:Co(SH7125)											*/
/*  쐬      :2012/04/15												*/
/*	쐬		:T.Kusumi												*/
/*	vWFNg:}CN}EXŊyg							*/
/*	W[	:Rg[											*/
/************************************************************************/
#include	"common.h"
#include	"ctrl.h"
/************************************************/
/*	LEDS_					(ctrl_led_on)	*/
/************************************************/
/*	ׂĂLED_B						*/
/************************************************/
void ctrl_led_on(void)
{
	//LEDS_
	drv_led_r(LED_ON);				//E_
	drv_led_fr(LED_ON);				//OE_
	drv_led_fl(LED_ON);				//O_
	drv_led_l(LED_ON);				//_
}

/************************************************/
/*	LEDS					(ctrl_led_off)	*/
/************************************************/
/*	ׂĂLEDB						*/
/************************************************/
void ctrl_led_off(void)
{
	//LEDS
	drv_led_r(LED_OFF);				//E
	drv_led_fr(LED_OFF);			//OE
	drv_led_fl(LED_OFF);			//O
	drv_led_l(LED_OFF);				//
}

/************************************************/
/*	ELED					(ctrl_led_r)	*/
/************************************************/
/*	ELED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void ctrl_led_r(int i_stat)
{
	//LEDiEj
	drv_led_r(i_stat);
}

/************************************************/
/*	LED					(ctrl_led_l)	*/
/************************************************/
/*	LED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void ctrl_led_l(int i_stat)
{
	//LEDij
	drv_led_l(i_stat);
}

/************************************************/
/*	OELED					(ctrl_led_fr)	*/
/************************************************/
/*	OELED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void ctrl_led_fr(int i_stat)
{
	//LEDiOEj
	drv_led_fr(i_stat);
}

/************************************************/
/*	OLED					(ctrl_led_fl)	*/
/************************************************/
/*	OLED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void ctrl_led_fl(int i_stat)
{
	//LEDiOj
	drv_led_fl(i_stat);
}

/************************************************/
/*	O2LED					(ctrl_led_f)*/
/************************************************/
/*	O2LED̓_/sB					*/
/*----------------------------------------------*/
/*	IN :int i_stat c LED_OFF(0):			*/
/*					  LED_ON (1):_			*/
/************************************************/
void ctrl_led_f(int i_stat)
{
	//O2LED_
	drv_led_fr(i_stat);
	drv_led_fl(i_stat);
}

/************************************************/
/*	LED2i\				(ctrl_led_num)	*/
/************************************************/
/*	LED2i\B						*/
/*----------------------------------------------*/
/*	IN :int i_number c LEDɕ\鐔l		*/
/************************************************/
void ctrl_led_num(int i_number)
{
	//LED2i\B
	drv_led_r(i_number & 0x0001);			//1BITcE
	drv_led_fr((i_number & 0x0002) >> 1);	//2BITcOE
	drv_led_fl((i_number & 0x0004) >> 2);	//3BITcO
	drv_led_l((i_number & 0x0008) >>3);		//4BITc
}

/************************************************/
/*	XCb`iꊇj		(ctrl_sw_all)	*/
/************************************************/
/*	ׂ̃XCb`̏Ԃ擾ĕԂB		*/
/*----------------------------------------------*/
/*	OUT:unsigned char *o_sw_b c XCb`		*/
/*					             ON:SW_ON(0)	*/
/*		unsigned char *o_sw_y c XCb`		*/
/*					             ON:SW_ON(0)	*/
/*		unsigned char *o_sw_r c ԃXCb`		*/
/*					             ON:SW_ON(0)	*/
/************************************************/
void ctrl_sw_all(unsigned char *o_sw_b,
				 unsigned char *o_sw_y,
				 unsigned char *o_sw_r)
{
	//XCb`iꊇj
	*o_sw_b	= drv_sw_b();			//XCb`
	*o_sw_y	= drv_sw_y();			//XCb`
	*o_sw_r	= drv_sw_r();			//ԃXCb`
	//ǂꂩ̃XCb`ONȂ΁AׂẴXCb`OFFɂȂ܂ő҂B
	if (*o_sw_b == SW_ON || *o_sw_y == SW_ON || *o_sw_r == SW_ON)
	{
		while(drv_sw_b() == SW_ON || drv_sw_y() == SW_ON || drv_sw_r() == SW_ON);
	}
}

/************************************************/
/*	uU[						(ctrl_bz)	*/
/************************************************/
/*	gԂw肵ăuU[炷B		*/
/*----------------------------------------------*/
/*	IN :int i_freq   c g					*/
/*		int	i_ms     c (ms)				*/
/************************************************/
void ctrl_bz(int i_freq, int i_ms)
{
	//uU[
	drv_bz(i_freq, i_ms);				//炷
}

/************************************************/
/*	uU[ifBj	(ctrl_bz_melody)	*/
/************************************************/
/*	ge|w肵ăuU[炷B*/
/*	Ė炷ꍇɉȂȂ悤	*/
/*	ZԂ̊ԊuB						*/
/*----------------------------------------------*/
/*	IN :int i_freq  c g					*/
/*		int i_beat  c (l=2)			*/
/*		int i_tempo c e|(1Ԃ̔)		*/
/************************************************/
void ctrl_bz_melody(int i_freq, int i_beat, int i_tempo)
{
	//uU[ifBj
	int ms = (i_beat * 60 * 1000 / 2) / i_tempo;
	//
	drv_bz(i_freq, (int)(ms * 0.9));			//炷
	drv_bz(BZ_FREQ_REST, (int)(ms * 0.1));		//Ԋu
}

/************************************************/
/*	A/DϊiEZTj		(ctrl_adc_r)	*/
/************************************************/
/*	EZT̒l擾B					*/
/*----------------------------------------------*/
/*	RET:int			c ZTl					*/
/************************************************/
int ctrl_adc_r(void)
{
	//A/DϊiEZTj
	int	value;
	//EZT̒l擾
	value = drv_adc_r();
	//
	return value;
}

/************************************************/
/*	A/DϊiZTj		(ctrl_adc_l)	*/
/************************************************/
/*	ZT̒l擾B					*/
/*----------------------------------------------*/
/*	RET:int			c ZTl					*/
/************************************************/
int ctrl_adc_l(void)
{
	//A/DϊiZTj
	int	value;
	//ZT̒l擾
	value = drv_adc_l();
	//
	return value;
}

/************************************************/
/*	A/DϊiOEZTj	(ctrl_adc_fr)	*/
/************************************************/
/*	OEZT̒l擾B					*/
/*----------------------------------------------*/
/*	RET:int			c ZTl					*/
/************************************************/
int ctrl_adc_fr(void)
{
	//A/DϊiOEZTj
	int	value;
	//OEZT̒l擾
	value = drv_adc_fr();
	//
	return value;
}

/************************************************/
/*	A/DϊiOZTj	(ctrl_adc_fl)	*/
/************************************************/
/*	OZT̒l擾B					*/
/*----------------------------------------------*/
/*	RET:int			c ZTl					*/
/************************************************/
int ctrl_adc_fl(void)
{
	//A/DϊiOZTj
	int	value;
	//OZT̒l擾
	value = drv_adc_fl();
	//
	return value;
}

/************************************************/
/*	ʐMiAlMj(ctrl_com_send)	*/
/************************************************/
/*	𑗐MB							*/
/*----------------------------------------------*/
/*	IN :char *i_string	c 				*/
/*		int   i_int 	c l					*/
/*	RET:int	c COM_OK ( 0):					*/
/*			   COM_ERR(-1):G[				*/
/************************************************/
int ctrl_com_send(char *i_string, int i_int)
{
	//ʐMiAlMj
	int stat = COM_OK;
	//
	stat = ctrl_com_string(i_string);
	if(stat == COM_OK)
	{
		stat = ctrl_com_int(i_int);
	}
	//
	return stat;
}

/************************************************/
/*	ʐMi񑗐Mj	(ctrl_com_string)	*/
/************************************************/
/*	𑗐MB							*/
/*----------------------------------------------*/
/*	IN :char *i_string c 				*/
/*	RET:int	c COM_OK ( 0):					*/
/*			   COM_ERR(-1):G[				*/
/************************************************/
int ctrl_com_string(char *i_string)
{
	//ʐMi񑗐Mj
	int i;
	int stat = COM_OK;
	//
	for(i = 0; i < 1024; i++)
	{
		if(*i_string == 0)
		{
			//\0ŏI
			break;
		}
		stat = drv_com_send(*i_string);		//1M
		if(stat == COM_ERR)
		{
			break;
		}
		i_string++;
	}
	return stat;
}

/************************************************/
/*	ʐMilMj		(ctrl_com_int)	*/
/************************************************/
/*	int𕶎ɕϊđMB				*/
/*----------------------------------------------*/
/*	IN :int i_int c l						*/
/*	RET:int	c COM_OK ( 0):					*/
/*			   COM_ERR(-1):G[				*/
/************************************************/
int ctrl_com_int(int i_int)
{
	//ʐMilMj
	int i;
	int stat = COM_OK;
	char buf[6];
	int sign;
	char numStr[10] = "0123456789";
	//
	if(i_int < 0)
	{
		sign = -1;
	}
	else
	{
		sign = 1;
	}
	i_int = i_int * sign;
	//
	if(sign >= 0)
	{
		buf[0] = ' ';
	}
	else
	{
		buf[0] = '-';
	}
	buf[1] = numStr[(int)(i_int / 10000)];
	buf[2] = numStr[(int)((i_int % 10000) / 1000)];
	buf[3] = numStr[(int)((i_int % 1000) / 100)];
	buf[4] = numStr[(int)((i_int % 100) / 10)];
	buf[5] = numStr[(int)(i_int % 10)];
	//
	for(i = 0; i < 6; i++)
	{
		stat = drv_com_send(buf[i]);		//1M
		if(stat == COM_ERR)
		{
			break;
		}
	}
	//
	return stat;
}

/************************************************/
/*	[^[㎥				(ctrl_mtr_pw)	*/
/************************************************/
/*	[^[̗㎥ON/OFFsB				*/
/*----------------------------------------------*/
/*	IN :int i_stat c MTR_ON (0):㎥			*/
/*					  MTR_OFF(1):㎥		*/
/************************************************/
void ctrl_mtr_pw(int i_stat)
{
	//[^[㎥ ON/OFF
	drv_mtr_pw(i_stat);
}

/************************************************/
/*	[^[iOij	(ctrl_mtr_forward)	*/
/************************************************/
/*	AڕWxw肵čẼ[^[	*/
/*	OiB									*/
/*----------------------------------------------*/
/*	IN :int i_block c 搔(=1)			*/
/*		int	i_speed	c ڕWx					*/
/************************************************/
void ctrl_mtr_forward(int i_block, int i_speed)
{
	//[^[iOij
	int stepCount;						//sXebv
	//XebvJEgNA
	G_StepCountR = 0;
	G_StepCountL = 0;
	//ݑxŒᑬxɐݒ肷B
	G_CurrentSpeedR = MIN_SPEED;
	G_CurrentSpeedL = MIN_SPEED;
	//sXebvZo
	stepCount = (int)(((float)i_block / (float)ONE_BLOCK)
	                * ((float)BLOCK_LENGTH / (float)STEP_LENGTH));
	//ōx
	G_MaxSpeedR = i_speed;
	G_MaxSpeedL = i_speed;
	//l
	G_AccelValue = ACCEL_VALUE;
	G_AccelCount = 0;
	//ǃ`FbNL
	G_WallCheckFlag = FLAG_ON;
	//[^[iOij
	drv_mtr(MTR_RUN, MTR_RUN);			//E[^Oi
	//ڕWn_܂ős
	ctrl_mtr_wait(stepCount);
	//Oǂŋ𒲐
	if(ctrl_wall_chk_f(WALL_THRESHOLD_F) == WALL_ON)
	{
		//Oǂ
		if(ctrl_wall_chk_f(CTRL_WALL_THRESHOLD_F) == WALL_OFF)
		{
			//ɒBĂȂ
			while(ctrl_wall_chk_f(CTRL_WALL_THRESHOLD_F) == WALL_OFF)
			{
			}
		}
	}
	//[^[i~j
	drv_mtr(MTR_STOP, MTR_STOP);		//E[^~
}

/************************************************/
/*	[^[ij		(ctrl_mtr_turn)	*/
/************************************************/
/*	]pxw肵Đ񂷂B				*/
/*----------------------------------------------*/
/*	IN :int i_angle c px()				*/
/*						> 0 c E			*/
/*                      < 0 c 			*/
/************************************************/
void ctrl_mtr_turn(int i_angle)
{
	//[^[ij
	int angle;              //px
	int mtrDirectionR;		//E[^[]
	int mtrDirectionL;		//[^[]
	int stepCount;			//sXebv
	//]
	if(i_angle > 0)
	{
		//E
		angle      = i_angle;
		mtrDirectionR = MTR_BACK;		//E[^[i
		mtrDirectionL  = MTR_RUN;		//[^[Oi
	}
	else
	{
		//
		angle      = -i_angle;
		mtrDirectionR = MTR_RUN;		//E[^[Oi
		mtrDirectionL  = MTR_BACK;		//[^[i
	}
	//XebvJEgNA
	G_StepCountR = 0;
	G_StepCountL = 0;
	//ݑxŒᑬxɐݒ肷B
	G_CurrentSpeedR = MIN_SPEED;
	G_CurrentSpeedL = MIN_SPEED;
	//sXebvZo
	stepCount = (int)((float)TREAD_CIRCUIT
	                * ((float)angle / (float)360.0)
					/ (float)STEP_LENGTH);
	//ōx
	G_MaxSpeedR = TURN_SPEED;
	G_MaxSpeedL = TURN_SPEED;
	//l
	G_AccelValue = ACCEL_VALUE;
	G_AccelCount = 0;
	//ǃ`FbN
	G_WallCheckFlag = FLAG_OFF;
	//[^[ij
	drv_mtr(mtrDirectionR, mtrDirectionL);
	//ڕWn_܂ős
	ctrl_mtr_wait(stepCount);
	//[^[i~j
	drv_mtr(MTR_STOP, MTR_STOP);		//E[^~
}

/************************************************/
/*	[^[iwaitj		(ctrl_mtr_wait)	*/
/************************************************/
/*	[^wXebv܂ŉ]̂҂B*/
/*  n_ɂȂ猸B                */
/************************************************/
void ctrl_mtr_wait(int i_stepCount)
{
	while(G_StepCountR < i_stepCount || G_StepCountL < i_stepCount)	//Ẽ[^sXebvɒB܂Ń[v
	{
		if(G_AccelValue > 0)
		{
			//
			if(G_AccelCount != 0)
			{
				if((i_stepCount - G_StepCountR < G_AccelCount) ||
				   (i_stepCount - G_StepCountL < G_AccelCount))
				{
					//n_ɂȂ猸Jn
					G_AccelValue = -ACCEL_VALUE;
				}
			}
			else
			{
				if((i_stepCount <= G_StepCountR * 2) ||
				   (i_stepCount <= G_StepCountL * 2))
				{
					//Ԓn_ɂȂ猸Jn
					G_AccelValue = -ACCEL_VALUE;
				}
			}
		}
	}
}

/************************************************/
/*	Eǂőx		(ctrl_wall_adjust)	*/
/************************************************/
/*	Eǂ̈ʒuŃ[^[x𒲐B	*/
/*----------------------------------------------*/
/*	RET:int	c l							*/
/************************************************/
int ctrl_wall_adjust(void)
{
	//Eǂőx
	int ret;						//߂lilj
	int rightwall;					//EǗL
	int leftwall;					//ǗL
	int rightdistance;				//Eǐڋ
	int leftdistance;				//ǐڋ
	//ǃ`FbN̂Ƃ́AOԂB
	if(G_WallCheckFlag == FLAG_OFF)
	{
		return 0;
	}
	//lNA
	ret = 0;
	//EǗL擾
	rightwall = ctrl_wall_chk_r(WALL_THRESHOLD_R);
	leftwall = ctrl_wall_chk_l(WALL_THRESHOLD_L);
	//Eǐڋߏ擾
	rightdistance = ctrl_wall_chk_r(CTRL_WALL_THRESHOLD_R);
	leftdistance = ctrl_wall_chk_l(CTRL_WALL_THRESHOLD_L);
	//Eǃ`FbN
	if(rightwall == WALL_ON && rightdistance == WALL_ON)
	{
		//Eǂ  Eǐڋ
		ret = (int)((float)G_SensorR * CTRL_GAIN); 
	}
	//ǃ`FbN
	if(leftwall == WALL_ON && leftdistance == WALL_ON)
	{
		//ǂ  ǐڋ
		ret = -(int)((float)G_SensorL * CTRL_GAIN); 
	}
	//
	return ret;
}

/************************************************/
/*	[^[MTU				(ctrl_mtu)		*/
/************************************************/
/*	[^[MTU̎ݒ肷B				*/
/*----------------------------------------------*/
/*	IN :int i_speed_r c E[^[Xs[h		*/
/*	    int i_speed_l c [^[Xs[h		*/
/************************************************/
void ctrl_mtu(int i_speed_r,int i_speed_l)
{
	//E[^[MTU̎ƃpXݒ肷B
	float cycle_r;
	float cycle_l;
	//
	cycle_r = (float)(STEP_LENGTH / i_speed_r * MTU_MTR_CLOCK);
	cycle_l = (float)(STEP_LENGTH / i_speed_l * MTU_MTR_CLOCK);
	//
	drv_mtu((int)cycle_r, (int)cycle_l);
}

/************************************************/
/*	EFCg					(ctrl_wait_ms)	*/
/************************************************/
/*	msPʂő҂Ԃ𐶐B				*/
/*----------------------------------------------*/
/*	IN :int i_ms c ҂(ms)				*/
/************************************************/
void ctrl_wait_ms(int i_ms)
{
	//msPʂő҂Ԃ𐶐B
	drv_wait_ms(i_ms);
}

/************************************************/
/*	Eǃ`FbN			(ctrl_wall_chk_r)	*/
/************************************************/
/*	EZT̒l擾A臒l𒴂Ă邩	*/
/*	`FbNB								*/
/*----------------------------------------------*/
/*	IN :int i_threshold c 臒l					*/
/*	RET:int             c WALL_OFF(0):ǖ	*/
/*						   WALL_ON (1):ǗL	*/
/************************************************/
int ctrl_wall_chk_r(int i_threshold)
{
	//Eǃ`FbN
	int ret;
	//EZT̒l臒l𒴂Ă邩`FbNB
	if (G_SensorR > i_threshold)
	{
		ret = WALL_ON;				//ǗL
	}
	else
	{
		ret = WALL_OFF;				//ǖ
	}
	return ret;
}

/************************************************/
/*	ǃ`FbN			(ctrl_wall_chk_l)	*/
/************************************************/
/*	ZT̒l擾A臒l𒴂Ă邩	*/
/*	`FbNB								*/
/*----------------------------------------------*/
/*	IN :int i_threshold c 臒l					*/
/*	RET:int             c WALL_OFF(0):ǖ	*/
/*						   WALL_ON (1):ǗL	*/
/************************************************/
int ctrl_wall_chk_l(int i_threshold)
{
	//ǃ`FbN
	int ret;
	//ZT̒l臒l𒴂Ă邩`FbNB
	if (G_SensorL > i_threshold)
	{
		ret = WALL_ON;				//ǗL
	}
	else
	{
		ret = WALL_OFF;				//ǖ
	}
	return ret;
}

/************************************************/
/*	Oǃ`FbN			(ctrl_wall_chk_f)	*/
/************************************************/
/*	OEAOZT̒l擾Aϒl臒l*/
/*	Ă邩`FbNB					*/
/*----------------------------------------------*/
/*	IN :int i_threshold c 臒l					*/
/*	RET:int             c WALL_OFF(0):ǖ	*/
/*						   WALL_ON (1):ǗL	*/
/************************************************/
int ctrl_wall_chk_f(int i_threshold)
{
	//Oǃ`FbN
	int ret;
	//OEZTAOZT̕ϒl臒l𒴂Ă邩`FbNB
	if ((G_SensorFR + G_SensorFL) / 2 > i_threshold)
	{
		ret = WALL_ON;				//ǗL
	}
	else
	{
		ret = WALL_OFF;				//ǖ
	}
	return ret;
}
