/************************************************************************/
/*  t@C  :interrupt.c											*/
/*  H/W			:Pi:Co(SH7125)											*/
/*  쐬      :2012/04/15												*/
/*	쐬		:T.Kusumi												*/
/*	vWFNg:}CN}EXŊyg							*/
/*	W[	:ݏ												*/
/************************************************************************/
#include	"iodefine.h"
#include	"common.h"
#include	"intrpt.h"

/************************************************/
/*	CMT0ݏ					(int_cmt0)	*/
/************************************************/
/*	^C}[(1ms)							*/
/************************************************/
void int_cmt0(void)
{
	int adjust;							//[^[xl
	//^C}[(1ms)	
	CMT0_INT_F = 0;			//tONA
	//^C}[JEg
	G_TimerCount++;			//1msƂɃJEgAbv
	//[^[
	if(G_CurrentSpeedR != 0 || G_CurrentSpeedL != 0)
	{
		//
		G_CurrentSpeedR += G_AccelValue;
		G_CurrentSpeedL += G_AccelValue;
		//Œᑬx`FbN
		if(G_CurrentSpeedR != 0 && G_CurrentSpeedR < MIN_SPEED)
		{
			G_CurrentSpeedR = MIN_SPEED;
		}
		if(G_CurrentSpeedL != 0 && G_CurrentSpeedL < MIN_SPEED)
		{
			G_CurrentSpeedL = MIN_SPEED;
		}
		//ōx`FbN
		if(G_CurrentSpeedR > G_MaxSpeedR)
		{
			G_CurrentSpeedR = G_MaxSpeedR;
			if(G_AccelCount == 0)
			{
				G_AccelCount = G_StepCountR;
			}
		}
		if(G_CurrentSpeedL > G_MaxSpeedL)
		{
			G_CurrentSpeedL = G_MaxSpeedL;
			if(G_AccelCount == 0)
			{
				G_AccelCount = G_StepCountL;
			}
		}
		//Eǂőx
		adjust = ctrl_wall_adjust();
		//MTUݒ
		ctrl_mtu(G_CurrentSpeedR + adjust, G_CurrentSpeedL - adjust);
	}
}

/************************************************/
/*	CMT1ݏ					(int_cmt1)	*/
/************************************************/
/*	ZT[`FbNp^C}[荞(0.25ms)	*/
/*	0:Eǃ`FbN								*/
/*	1:ǃ`FbN								*/
/*	2:OEǃ`FbN							*/
/*	3:Oǃ`FbN							*/
/************************************************/
void int_cmt1(void)
{
	//ZT[p^C}[荞(0.25ms)
	static int state = 0;	//ǂݍރZT̃[e[VǗpϐ
	//
	CMT1_INT_F = 0;			//tONA
	//
	switch(state)
	{
		case 0:				//Eǃ`FbN
			G_SensorR = ctrl_adc_r();					//EZTl擾
			break;
		case 1:				//ǃ`FbN
			G_SensorL = ctrl_adc_l();					//ZTl擾
			break;
		case 2:				//OEǃ`FbN
			G_SensorFR = ctrl_adc_fr();					//OEZTl擾
			break;
		case 3:				//Oǃ`FbN
			G_SensorFL = ctrl_adc_fl();					//OZTl擾
			break;
	}
	//
	state++;		//S񂲂ƂɌJԂ
	if(state >= 4)
	{
		state = 0;
	}
}

/************************************************/
/*	E[^[MTUݏ			(int_mtr_r)	*/
/************************************************/
/*	E[^[PXebviޖ̊		*/
/************************************************/
void int_mtr_r(void)
{
	//E[^[PXebviޖ̊
	MTU_R_INT_F = 0;		//tONA
	//
	G_StepCountR++;			//XebvJEg
}

/************************************************/
/*	[^[MTUݏ			(int_mtr_l)	*/
/************************************************/
/*	[^[PXebviޖ̊		*/
/************************************************/
void int_mtr_l(void)
{
	//[^[PXebviޖ̊
	MTU_L_INT_F = 0;		//tONA
	//
	G_StepCountL++;			//XebvJEg
}
